| Home · All Classes · All Namespaces · Modules · Functions · Files

Signals | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Properties

# Tp::Account Class Reference
[Account proxies]

The Account class provides an object representing a Telepathy account. More...

`#include <TelepathyQt4/Account>`

Inherits Tp::StatelessDBusProxy, OptionalInterfaceFactory< Account >, Tp::ReadyObject, and Tp::RefCounted.

List of all members.

## Signals

- void removed ()
- void serviceNameChanged (const QString &serviceName)
- void profileChanged (const Tp::ProfilePtr &profile)
- void displayNameChanged (const QString &displayName)
- void iconChanged (const QString &iconName)
- void iconNameChanged (const QString &iconName)
- void nicknameChanged (const QString &nickname)
- void normalizedNameChanged (const QString &normalizedName)
- void validityChanged (bool validity)
- void stateChanged (bool state)
- void capabilitiesChanged (Tp::ConnectionCapabilities *capabilities)
- void connectsAutomaticallyPropertyChanged (bool connectsAutomatically)
- void firstOnline ()
- void parametersChanged (const QVariantMap &parameters)
- void changingPresence (bool value)
- void automaticPresenceChanged (const Tp::SimplePresence &automaticPresence) const
- void currentPresenceChanged (const Tp::SimplePresence &currentPresence) const
- void requestedPresenceChanged (const Tp::SimplePresence &requestedPresence) const
- void onlinenessChanged (bool online)
- void avatarChanged (const Tp::Avatar &avatar)
- void connectionStatusChanged (Tp::Connection::Status status)
- void connectionStatusChanged (Tp::ConnectionStatus status, Tp::ConnectionStatusReason statusReason)
- void statusChanged (Tp::ConnectionStatus status, Tp::ConnectionStatusReason statusReason, const QString &error, const QVariantMap &errorDetails)
- void connectionChanged (const Tp::ConnectionPtr &connection)
- void haveConnectionChanged (bool haveConnection)
- void propertyChanged (const QString &propertyName)

## Public Member Functions

- virtual ~Account ()
- ConnectionFactoryConstPtr connectionFactory () const
- ChannelFactoryConstPtr channelFactory () const
- ContactFactoryConstPtr contactFactory () const
- bool isValidAccount () const
- bool isEnabled () const
- PendingOperation * setEnabled (bool value)
- QString cmName () const
- TELEPATHY_QT4_DEPRECATED QString protocol () const
- QString protocolName () const
- QString serviceName () const
- PendingOperation * setServiceName (const QString &value)
- ProfilePtr profile () const
- QString displayName () const
- PendingOperation * setDisplayName (const QString &value)
- TELEPATHY_QT4_DEPRECATED QString icon () const
- QString iconName () const
- TELEPATHY_QT4_DEPRECATED
  PendingOperation * setIcon (const QString &value)
- PendingOperation * setIconName (const QString &value)
- QString nickname () const
- PendingOperation * setNickname (const QString &value)
- const Avatar & avatar () const
- PendingOperation * setAvatar (const Avatar &avatar)
- QVariantMap parameters () const
- PendingStringList * updateParameters (const QVariantMap &set, const QStringList &unset)
- ProtocolInfo * protocolInfo () const
- ConnectionCapabilities * capabilities () const
- bool connectsAutomatically () const
- PendingOperation * setConnectsAutomatically (bool value)
- bool hasBeenOnline () const
- ConnectionStatus connectionStatus () const
- ConnectionStatusReason connectionStatusReason () const
- QString connectionError () const
- QVariantMap connectionErrorDetails () const
- TELEPATHY_QT4_DEPRECATED bool haveConnection () const
- ConnectionPtr connection () const
- bool isChangingPresence () const
- SimplePresence automaticPresence () const
- PendingOperation * setAutomaticPresence (const SimplePresence &value)
- SimplePresence currentPresence () const
- SimplePresence requestedPresence () const
- PendingOperation * setRequestedPresence (const SimplePresence &value)
- bool isOnline () const
- QString uniqueIdentifier () const
- TELEPATHY_QT4_DEPRECATED QString connectionObjectPath () const
- QString normalizedName () const
- PendingOperation * reconnect ()
- PendingOperation * remove ()
- PendingChannelRequest * ensureTextChat (const QString &contactIdentifier, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureTextChat (const ContactPtr &contact, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureTextChatroom (const QString &roomName, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaCall (const QString &contactIdentifier, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaCall (const ContactPtr &contact, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaAudioCall (const QString &contactIdentifier, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaAudioCall (const ContactPtr &contact, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaVideoCall (const QString &contactIdentifier, bool withAudio=true, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureStreamedMediaVideoCall (const ContactPtr &contact, bool withAudio=true, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureMediaCall (const QString &contactIdentifier, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureMediaCall (const ContactPtr &contact, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureAudioCall (const QString &contactIdentifier, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureAudioCall (const ContactPtr &contact, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureVideoCall (const QString &contactIdentifier, bool withAudio=true, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * ensureVideoCall (const ContactPtr &contact, bool withAudio=true, QDateTime userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createFileTransfer (const QString &contactIdentifier, const FileTransferChannelCreationProperties &properties, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createFileTransfer (const ContactPtr &contact, const FileTransferChannelCreationProperties &properties, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * createConferenceMediaCall (const QList< ChannelPtr > &channels, const QStringList &initialInviteeContactsIdentifiers=QStringList(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * createConferenceMediaCall (const QList< ChannelPtr > &channels, const QList< ContactPtr > &initialInviteeContacts=QList< ContactPtr >(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceStreamedMediaCall (const QList< ChannelPtr > &channels, const QStringList &initialInviteeContactsIdentifiers=QStringList(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceStreamedMediaCall (const QList< ChannelPtr > &channels, const QList< ContactPtr > &initialInviteeContacts=QList< ContactPtr >(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceTextChat (const QList< ChannelPtr > &channels, const QList< ContactPtr > &initialInviteeContacts=QList< ContactPtr >(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceTextChat (const QList< ChannelPtr > &channels, const QStringList &initialInviteeContactsIdentifiers=QStringList(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceTextChatRoom (const QString &roomName, const QList< ChannelPtr > &channels, const QStringList &initialInviteeContactsIdentifiers=QStringList(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createConferenceTextChatRoom (const QString &roomName, const QList< ChannelPtr > &channels, const QList< ContactPtr > &initialInviteeContacts=QList< ContactPtr >(), const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createContactSearch (const QString &server=QString(), uint limit=0, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  PendingChannelRequest * createContactSearchChannel (const QString &server=QString(), uint limit=0, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * createChannel (const QVariantMap &requestedProperties, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- PendingChannelRequest * ensureChannel (const QVariantMap &requestedProperties, const QDateTime &userActionTime=QDateTime::currentDateTime(), const QString &preferredHandler=QString())
- TELEPATHY_QT4_DEPRECATED
  Client::DBus::PropertiesInterface * propertiesInterface () const
- TELEPATHY_QT4_DEPRECATED
  Client::AccountInterfaceAvatarInterface * avatarInterface (InterfaceSupportedChecking check=CheckInterfaceSupported) const

## Static Public Member Functions

- static AccountPtr create (const QString &busName, const QString &objectPath)
- static
  TELEPATHY_QT4_DEPRECATED
  AccountPtr create (const QDBusConnection &bus, const QString &busName, const QString &objectPath)
- static AccountPtr create (const QString &busName, const QString &objectPath, const ConnectionFactoryConstPtr &connectionFactory, const ChannelFactoryConstPtr &channelFactory=ChannelFactory::create(QDBusConnection::sessionBus()), const ContactFactoryConstPtr &contactFactory=ContactFactory::create())
- static AccountPtr create (const QDBusConnection &bus, const QString &busName, const QString &objectPath, const ConnectionFactoryConstPtr &connectionFactory, const ChannelFactoryConstPtr &channelFactory, const ContactFactoryConstPtr &contactFactory=ContactFactory::create())

## Static Public Attributes

- static const Feature FeatureCore
- static const Feature FeatureAvatar
- static const Feature FeatureProtocolInfo
- static const Feature FeatureCapabilities
- static const Feature FeatureProfile

## Protected Member Functions

- TELEPATHY_QT4_DEPRECATED Account (const QString &busName, const QString &objectPath)
- TELEPATHY_QT4_DEPRECATED Account (const QDBusConnection &bus, const QString &busName, const QString &objectPath)
- Account (const QDBusConnection &bus, const QString &busName, const QString &objectPath, const ConnectionFactoryConstPtr &connectionFactory, const ChannelFactoryConstPtr &channelFactory, const ContactFactoryConstPtr &contactFactory)
- Client::AccountInterface * baseInterface () const
- void connectNotify (const char *)

## Properties

- bool valid
- bool enabled
- QString cmName
- QString protocolName
- QString serviceName
- ProfilePtr profile
- QString displayName
- QString iconName
- QString nickname
- Avatar avatar
- QVariantMap parameters
- ProtocolInfo protocolInfo
- ConnectionCapabilities capabilities
- bool hasBeenOnline
- bool connectsAutomatically
- ConnectionStatus connectionStatus
- ConnectionStatusReason connectionStatusReason
- QString connectionError
- QVariantMap connectionErrorDetails
- bool haveConnection
- ConnectionPtr connection
- bool changingPresence
- SimplePresence automaticPresence
- SimplePresence currentPresence
- SimplePresence requestedPresence
- bool online
- QString uniqueIdentifier
- QString connectionObjectPath
- QString normalizedName

## Detailed Description

The Account class provides an object representing a Telepathy account.

Account adds the following features compared to using Client::AccountManagerInterface directly:

- Status tracking
- Getting the list of supported interfaces automatically

The remote object accessor functions on this object (isValidAccount(), isEnabled(), and so on) don't make any D-Bus calls; instead, they return/use values cached from a previous introspection run. The introspection process populates their values in the most efficient way possible based on what the service implements. Their return value is mostly undefined until the introspection process is completed, i.e. isReady() returns true. See the individual accessor descriptions for more details.

Signals are emitted to indicate that properties have changed, for example displayNameChanged(), iconNameChanged(), etc.

Convenience methods to create channels using the channel dispatcher such as ensureTextChat(), createFileTransfer() are provided.

To avoid unnecessary D-Bus traffic, some methods only return valid information after a specific feature has been enabled by calling becomeReady() with the desired set of features as an argument, and waiting for the resulting PendingOperation to finish. For instance, to retrieve the account protocol information, it is necessary to call becomeReady() with Account::FeatureProtocolInfo included in the argument. The required features are documented by each method.

If the account is deleted from the AccountManager, this object will not be deleted automatically; however, it will emit invalidated() with error code TELEPATHY_QT4_ERROR_OBJECT_REMOVED and will cease to be useful.

## Usage

### Creating an account object

The easiest way to create account objects is through AccountManager. One can just use the AccountManager convenience methods such as AccountManager::validAccounts() to get a list of account objects representing valid accounts.

If you already know the object path, you can just call create(). For example:

     AccountPtr acc = Account::create(busName, objectPath);

An AccountPtr object is returned, which will automatically keep track of object lifetime.

You can also provide a D-Bus connection as a QDBusConnection:

     AccountPtr acc = Account::create(QDBusConnection::sessionBus(),
             busName, objectPath);

### Making account ready to use

An Account object needs to become ready before usage, meaning that the introspection process finished and the object accessors can be used.

To make the object ready, use becomeReady() and wait for the PendingOperation::finished() signal to be emitted.

     class MyClass : public QObject
     {
         QOBJECT

     public:
         MyClass(QObject *parent = 0);
         ~MyClass() { }

     private Q_SLOTS:
         void onAccountReady(Tp::PendingOperation*);

     private:
         AccountPtr acc;
     };

     MyClass::MyClass(const QString &busName, const QString &objectPath,
             QObject *parent)
         : QObject(parent)
           acc(Account::create(busName, objectPath))
     {
         connect(acc->becomeReady(),
                 SIGNAL(finished(Tp::PendingOperation*)),
                 SLOT(onAccountReady(Tp::PendingOperation*)));
     }

     void MyClass::onAccountReady(Tp::PendingOperation *op)
     {
         if (op->isError()) {
             qWarning() << "Account cannot become ready:" <<
                 op->errorName() << "-" << op->errorMessage();
             return;
         }

         // Account is now ready
         qDebug() << "Display name:" << acc->displayName();
     }

See Asynchronous Object Model, Shared Pointer Usage

## Constructor & Destructor Documentation

Tp::Account::~Account | ( |  | ) | `[virtual]`

Class destructor.

Tp::Account::Account | ( | const QString & | busName,
|  | const QString & | objectPath |
| ) |  |  | `[protected]`

Construct a new Account object using QDBusConnection::sessionBus().

The instance will use a connection factory creating Tp::Connection objects with no features ready, and a channel factory creating stock Telepathy-Qt4 channel subclasses, as appropriate, with no features ready.

Deprecated:

Parameters:

  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.

Tp::Account::Account | ( | const QDBusConnection & | bus,
|  | const QString & | busName,
|  | const QString & | objectPath |
| ) |  |  | `[protected]`

Construct a new Account object using the given bus.

The instance will use a connection factory creating Tp::Connection objects with no features ready, and a channel factory creating stock Telepathy-Qt4 channel subclasses, as appropriate, with no features ready.

Deprecated:

Parameters:

  | bus | QDBusConnection to use.
  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.

Tp::Account::Account | ( | const QDBusConnection & | bus,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | const ConnectionFactoryConstPtr & | connectionFactory,
|  | const ChannelFactoryConstPtr & | channelFactory,
|  | const ContactFactoryConstPtr & | contactFactory |
| ) |  |  | `[protected]`

Construct a new Account object using the given bus and the given factories.

A warning is printed if the factories are not for bus.

Parameters:

  | bus | QDBusConnection to use.
  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.
  | connectionFactory | The connection factory to use.
  | channelFactory | The channel factory to use.
  | contactFactory | The contact factory to use.

## Member Function Documentation

AccountPtr Tp::Account::create | ( | const QString & | busName,
|  | const QString & | objectPath |
| ) |  |  | `[static]`

Create a new Account object using QDBusConnection::sessionBus().

The instance will use a connection factory creating Tp::Connection objects with no features ready, and a channel factory creating stock Telepathy-Qt4 channel subclasses, as appropriate, with no features ready.

Parameters:

  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.

Returns:
  An AccountPtr object pointing to the newly created Account object.

AccountPtr Tp::Account::create | ( | const QDBusConnection & | bus,
|  | const QString & | busName,
|  | const QString & | objectPath |
| ) |  |  | `[static]`

Create a new Account object using the given bus.

The instance will use a connection factory creating Tp::Connection objects with no features ready, and a channel factory creating stock Telepathy-Qt4 channel subclasses, as appropriate, with no features ready.

Deprecated:
  Use other create() methods.

Parameters:

  | bus | QDBusConnection to use.
  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.

Returns:
  An AccountPtr object pointing to the newly created Account object.

AccountPtr Tp::Account::create | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | const ConnectionFactoryConstPtr & | connectionFactory,
|  | const ChannelFactoryConstPtr & | channelFactory = `ChannelFactory::create(QDBusConnection::sessionBus())`,
|  | const ContactFactoryConstPtr & | contactFactory = `ContactFactory::create()` |
| ) |  |  | `[static]`

Create a new Account object using QDBusConnection::sessionBus() and the given factories.

A warning is printed if the factories are not for QDBusConnection::sessionBus().

Parameters:

  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.
  | connectionFactory | The connection factory to use.
  | channelFactory | The channel factory to use.
  | contactFactory | The contact factory to use.

Returns:
  An AccountPtr object pointing to the newly created Account object.

AccountPtr Tp::Account::create | ( | const QDBusConnection & | bus,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | const ConnectionFactoryConstPtr & | connectionFactory,
|  | const ChannelFactoryConstPtr & | channelFactory,
|  | const ContactFactoryConstPtr & | contactFactory = `ContactFactory::create()` |
| ) |  |  | `[static]`

Create a new Account object using the given bus and the given factories.

A warning is printed if the factories are not for bus.

Parameters:

  | bus | QDBusConnection to use.
  | busName | The account well-known bus name (sometimes called a "service name"). This is usually the same as the account manager bus name TELEPATHY_ACCOUNT_MANAGER_BUS_NAME.
  | objectPath | The account object path.
  | connectionFactory | The connection factory to use.
  | channelFactory | The channel factory to use.
  | contactFactory | The contact factory to use.

Returns:
  An AccountPtr object pointing to the newly created Account object.

ConnectionFactoryConstPtr Tp::Account::connectionFactory | ( |  | ) | const

Get the connection factory used by this account.

Only read access is provided. This allows constructing object instances and examining the object construction settings, but not changing settings. Allowing changes would lead to tricky situations where objects constructed at different times by the account would have unpredictably different construction settings (eg. subclass).

Returns:
  Read-only pointer to the factory.

ChannelFactoryConstPtr Tp::Account::channelFactory | ( |  | ) | const

Get the channel factory used by this account.

Only read access is provided. This allows constructing object instances and examining the object construction settings, but not changing settings. Allowing changes would lead to tricky situations where objects constructed at different times by the account would have unpredictably different construction settings (eg. subclass).

Returns:
  Read-only pointer to the factory.

ContactFactoryConstPtr Tp::Account::contactFactory | ( |  | ) | const

Get the contact factory used by this account.

Only read access is provided. This allows constructing object instances and examining the object construction settings, but not changing settings. Allowing changes would lead to tricky situations where objects constructed at different times by the account would have unpredictably different construction settings (eg. subclass).

Returns:
  Read-only pointer to the factory.

bool Tp::Account::isValidAccount | ( |  | ) | const

Return whether this is a valid account.

If true, this account is considered by the account manager to be complete and usable. If false, user action is required to make it usable, and it will never attempt to connect (for instance, this might be caused by the absence of a required parameter).

This method requires Account::FeatureCore to be enabled.

Returns:
  `true` if the account is valid, `false` otherwise.

See also:
  validityChanged()

bool Tp::Account::isEnabled | ( |  | ) | const

Return whether this account is enabled.

Gives the users the possibility to prevent an account from being used. This flag does not change the validity of the account.

This method requires Account::FeatureCore to be enabled.

Returns:
  `true` if the account is enabled, `false` otherwise.

See also:
  stateChanged()

PendingOperation * Tp::Account::setEnabled | ( | bool | value | ) |

Set whether this account should be enabled or disabled.

Parameters:

  | value | Whether this account should be enabled or disabled.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  stateChanged()

QString Tp::Account::cmName | ( |  | ) | const

QString Tp::Account::protocol | ( |  | ) | const

Return the protocol name of this account.

This method requires Account::FeatureCore to be enabled.

Deprecated:
  Use protocolName() methods.

Returns:
  The protocol name of this account.

QString Tp::Account::protocolName | ( |  | ) | const

QString Tp::Account::serviceName | ( |  | ) | const

PendingOperation * Tp::Account::setServiceName | ( | const QString & | value | ) |

Set the service name of this account.

Parameters:

  | value | The service name of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  serviceNameChanged()

ProfilePtr Tp::Account::profile | ( |  | ) | const

QString Tp::Account::displayName | ( |  | ) | const

PendingOperation * Tp::Account::setDisplayName | ( | const QString & | value | ) |

Set the display name of this account.

Parameters:

  | value | The display name of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  displayNameChanged()

QString Tp::Account::icon | ( |  | ) | const

Return the icon name of this account.

This method requires Account::FeatureCore to be enabled.

Deprecated:
  Use iconName() instead.

Returns:
  The icon name of this account.

See also:
  iconChanged()

QString Tp::Account::iconName | ( |  | ) | const

PendingOperation * Tp::Account::setIcon | ( | const QString & | value | ) |

Set the icon name of this account.

Deprecated:
  Use setIconName() instead.

Parameters:

  | value | The icon name of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  iconChanged()

PendingOperation * Tp::Account::setIconName | ( | const QString & | value | ) |

Set the icon name of this account.

Parameters:

  | value | The icon name of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  iconNameChanged()

QString Tp::Account::nickname | ( |  | ) | const

PendingOperation * Tp::Account::setNickname | ( | const QString & | value | ) |

Set the nickname of this account.

Parameters:

  | value | The nickname of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  nicknameChanged()

const Avatar& Tp::Account::avatar | ( |  | ) | const

PendingOperation * Tp::Account::setAvatar | ( | const Avatar & | avatar | ) |

Set avatar of this account.

Parameters:

  | avatar | The avatar of this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  avatarChanged()

QVariantMap Tp::Account::parameters | ( |  | ) | const

PendingStringList * Tp::Account::updateParameters | ( | const QVariantMap & | set,
|  | const QStringList & | unset |
| ) |  |  |

Update this account parameters.

On success, the pending operation returned by this method will produce a list of strings, which are the names of parameters whose changes will not take effect until the account is disconnected and reconnected (for instance by calling reconnect()).

Parameters:

  | set | Parameters to set.
  | unset | Parameters to unset.

Returns:
  A PendingStringList which will emit PendingStringList::finished when the call has finished

See also:
  parametersChanged(), reconnect()

ProtocolInfo* Tp::Account::protocolInfo | ( |  | ) | const

ConnectionCapabilities* Tp::Account::capabilities | ( |  | ) | const

bool Tp::Account::connectsAutomatically | ( |  | ) | const

PendingOperation * Tp::Account::setConnectsAutomatically | ( | bool | value | ) |

Set whether this account should be put online automatically whenever possible.

Parameters:

  | value | Value indicating if this account should be put online whenever possible.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  connectsAutomaticallyPropertyChanged()

bool Tp::Account::hasBeenOnline | ( |  | ) | const

ConnectionStatus Tp::Account::connectionStatus | ( |  | ) | const

ConnectionStatusReason Tp::Account::connectionStatusReason | ( |  | ) | const

QString Tp::Account::connectionError | ( |  | ) | const

QVariantMap Tp::Account::connectionErrorDetails | ( |  | ) | const

TELEPATHY_QT4_DEPRECATED bool Tp::Account::haveConnection | ( |  | ) | const

ConnectionPtr Tp::Account::connection | ( |  | ) | const

bool Tp::Account::isChangingPresence | ( |  | ) | const

Return whether this account's connection is changing presence.

This method requires Account::FeatureCore to be enabled.

Returns:
  Whether this account's connection is changing presence.

See also:
  changingPresence(), currentPresenceChanged(), setRequestedPresence()

SimplePresence Tp::Account::automaticPresence | ( |  | ) | const

PendingOperation * Tp::Account::setAutomaticPresence | ( | const SimplePresence & | value | ) |

Set the presence status that this account should have if it is brought online automatically by the account manager.

Parameters:

  | value | The presence status to set when this account is brought online automatically by the account manager.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  automaticPresenceChanged(), setRequestedPresence()

SimplePresence Tp::Account::currentPresence | ( |  | ) | const

SimplePresence Tp::Account::requestedPresence | ( |  | ) | const

PendingOperation * Tp::Account::setRequestedPresence | ( | const SimplePresence & | value | ) |

Set the requested presence.

When requested presence is changed, the account manager should attempt to manipulate the connection to make currentPresence() match requestedPresence() as closely as possible.

Parameters:

  | value | The requested presence.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  requestedPresenceChanged(), currentPresence(), automaticPresence(), setAutomaticPresence()

bool Tp::Account::isOnline | ( |  | ) | const

Return whether this account is online.

Returns:
  `true` if this account is online, otherwise `false`.

QString Tp::Account::uniqueIdentifier | ( |  | ) | const

TELEPATHY_QT4_DEPRECATED QString Tp::Account::connectionObjectPath | ( |  | ) | const

QString Tp::Account::normalizedName | ( |  | ) | const

PendingOperation * Tp::Account::reconnect | ( |  | ) |

If this account is currently connected, disconnect and reconnect it. If it is currently trying to connect, cancel the attempt to connect and start another. If it is currently disconnected, do nothing.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

PendingOperation * Tp::Account::remove | ( |  | ) |

Delete this account.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

PendingChannelRequest * Tp::Account::ensureTextChat | ( | const QString & | contactIdentifier,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a text channel with the given contact contactIdentifier exists, creating it if necessary.

See ensureChannel() for more details.

Parameters:

  | contactIdentifier | The identifier of the contact to chat with.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureTextChat | ( | const ContactPtr & | contact,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a text channel with the given contact contact exists, creating it if necessary.

See ensureChannel() for more details.

Parameters:

  | contact | The contact to chat with.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureTextChatroom | ( | const QString & | roomName,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a text chat room with the given room name roomName exists, creating it if necessary.

See ensureChannel() for more details.

Parameters:

  | roomName | The name of the chat room.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaCall | ( | const QString & | contactIdentifier,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a media channel with the given contact contactIdentifier exists, creating it if necessary.

See ensureChannel() for more details.

Parameters:

  | contactIdentifier | The identifier of the contact to call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaCall | ( | const ContactPtr & | contact,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a media channel with the given contact contact exists, creating it if necessary.

See ensureChannel() for more details.

Parameters:

  | contact | The contact to call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaAudioCall | ( | const QString & | contactIdentifier,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that an audio call with the given contact contactIdentifier exists, creating it if necessary.

See ensureChannel() for more details.

This will only work on relatively modern connection managers, like telepathy-gabble 0.9.0 or later.

Parameters:

  | contactIdentifier | The identifier of the contact to call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaAudioCall | ( | const ContactPtr & | contact,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that an audio call with the given contact contact exists, creating it if necessary.

See ensureChannel() for more details.

This will only work on relatively modern connection managers, like telepathy-gabble 0.9.0 or later.

Parameters:

  | contact | The contact to call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaVideoCall | ( | const QString & | contactIdentifier,
|  | bool | withAudio = `true`,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a video call with the given contact contactIdentifier exists, creating it if necessary.

See ensureChannel() for more details.

This will only work on relatively modern connection managers, like telepathy-gabble 0.9.0 or later.

Parameters:

  | contactIdentifier | The identifier of the contact to call.
  | withAudio | true if both audio and video are required, false for a video-only call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureStreamedMediaVideoCall | ( | const ContactPtr & | contact,
|  | bool | withAudio = `true`,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a video call with the given contact contact exists, creating it if necessary.

See ensureChannel() for more details.

This will only work on relatively modern connection managers, like telepathy-gabble 0.9.0 or later.

Parameters:

  | contact | The contact to call.
  | withAudio | true if both audio and video are required, false for a video-only call.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::ensureMediaCall | ( | const QString & | contactIdentifier,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use ensureStreamedMediaCall() instead.

PendingChannelRequest * Tp::Account::ensureMediaCall | ( | const ContactPtr & | contact,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use ensureStreamedMediaCall() instead.

PendingChannelRequest * Tp::Account::ensureAudioCall | ( | const QString & | contactIdentifier,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use ensureStreamedMediaAudioCall() instead.

PendingChannelRequest * Tp::Account::ensureAudioCall | ( | const ContactPtr & | contact,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Use ensureStreamedMediaAudioCall() instead.

PendingChannelRequest * Tp::Account::ensureVideoCall | ( | const QString & | contactIdentifier,
|  | bool | withAudio = `true`,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  ensureStreamedMediaVideoCall() instead.

PendingChannelRequest * Tp::Account::ensureVideoCall | ( | const ContactPtr & | contact,
|  | bool | withAudio = `true`,
|  | QDateTime | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use ensureStreamedMediaVideoCall() instead.

PendingChannelRequest * Tp::Account::createFileTransfer | ( | const QString & | contactIdentifier,
|  | const FileTransferChannelCreationProperties & | properties,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a file transfer channel with the given contact contact.

Parameters:

  | contactIdentifier | The identifier of the contact to send a file.
  | fileName | The suggested filename for the receiver.
  | properties | The desired properties.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createFileTransfer | ( | const ContactPtr & | contact,
|  | const FileTransferChannelCreationProperties & | properties,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a file transfer channel with the given contact contact.

Parameters:

  | contact | The contact to send a file.
  | properties | The desired properties.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceMediaCall | ( | const QList< ChannelPtr > & | channels,
|  | const QStringList & | initialInviteeContactsIdentifiers = `QStringList()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use createConferenceStreamedMediaCall() instead.

PendingChannelRequest * Tp::Account::createConferenceMediaCall | ( | const QList< ChannelPtr > & | channels,
|  | const QList< ContactPtr > & | initialInviteeContacts = `QList<ContactPtr>()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use createConferenceStreamedMediaCall() instead.

PendingChannelRequest * Tp::Account::createConferenceStreamedMediaCall | ( | const QList< ChannelPtr > & | channels,
|  | const QStringList & | initialInviteeContactsIdentifiers = `QStringList()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference media call with the given channels channels.

Parameters:

  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts identifiers to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceStreamedMediaCall | ( | const QList< ChannelPtr > & | channels,
|  | const QList< ContactPtr > & | initialInviteeContacts = `QList<ContactPtr>()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference media call with the given channels channels.

Parameters:

  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceTextChat | ( | const QList< ChannelPtr > & | channels,
|  | const QList< ContactPtr > & | initialInviteeContacts = `QList<ContactPtr>()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference text chat with the given channels channels.

Parameters:

  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceTextChat | ( | const QList< ChannelPtr > & | channels,
|  | const QStringList & | initialInviteeContactsIdentifiers = `QStringList()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference text chat with the given channels channels.

Parameters:

  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts identifiers to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceTextChatRoom | ( | const QString & | roomName,
|  | const QList< ChannelPtr > & | channels,
|  | const QStringList & | initialInviteeContactsIdentifiers = `QStringList()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference text chat room with the given channels channels and room name roomName.

Parameters:

  | roomName | The room name.
  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts identifiers to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createConferenceTextChatRoom | ( | const QString & | roomName,
|  | const QList< ChannelPtr > & | channels,
|  | const QList< ContactPtr > & | initialInviteeContacts = `QList<ContactPtr>()`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a conference text chat room with the given channels channels and room name roomName.

Parameters:

  | roomName | The room name.
  | channels | The conference channels.
  | initialInviteeContactsIdentifiers | A list of additional contacts to be invited to this conference when it is created.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  ensureChannel(), createChannel()

PendingChannelRequest * Tp::Account::createContactSearch | ( | const QString & | server = `QString()`,
|  | uint | limit = `0`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a contact search channel with the given server server and limit limit.

Parameters:

  | server | For protocols which support searching for contacts on multiple servers with different DNS names (like XMPP), the DNS name of the server to be searched, e.g. "characters.shakespeare.lit". Otherwise, an empty string.
  | limit | The desired maximum number of results that should be returned by a doing a search. If the protocol does not support specifying a limit for the number of results returned at a time, this will be ignored.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

Returns:
  A PendingChannelRequest which will emit PendingChannelRequest::finished when the call has finished.

See also:
  createChannel()

PendingChannelRequest * Tp::Account::createContactSearchChannel | ( | const QString & | server = `QString()`,
|  | uint | limit = `0`,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Deprecated:
  Use createContactSearch() instead.

PendingChannelRequest * Tp::Account::createChannel | ( | const QVariantMap & | request,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to create a channel. This initially just creates a PendingChannelRequest object, which can be used to track the success or failure of the request, or to cancel it.

Helper methods for text chat, text chat room, media call and conference are provided and should be used if appropriate.

Parameters:

  | request | A dictionary containing desirable properties.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

See also:
  createChannel()

PendingChannelRequest * Tp::Account::ensureChannel | ( | const QVariantMap & | request,
|  | const QDateTime & | userActionTime = `QDateTime::currentDateTime()`,
|  | const QString & | preferredHandler = `QString()` |
| ) |  |  |

Start a request to ensure that a channel exists, creating it if necessary. This initially just creates a PendingChannelRequest object, which can be used to track the success or failure of the request, or to cancel it.

Helper methods for text chat, text chat room, media call and conference are provided and should be used if appropriate.

Parameters:

  | request | A dictionary containing desirable properties.
  | userActionTime | The time at which user action occurred, or QDateTime() if this channel request is for some reason not involving user action.
  | preferredHandler | Either the well-known bus name (starting with org.freedesktop.Telepathy.Client.) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable.

See also:
  createChannel()

Client::DBus::PropertiesInterface * Tp::Account::propertiesInterface | ( |  | ) | const`[inline]`

Convenience function for getting a PropertiesInterface interface proxy object for this account. The Account interface relies on properties, so this interface is always assumed to be present.

Deprecated:
  Use optionalInterface() instead.

Returns:
  A pointer to the existing Client::DBus::PropertiesInterface object for this Account object.

Client::AccountInterfaceAvatarInterface * Tp::Account::avatarInterface | ( | InterfaceSupportedChecking | check = `CheckInterfaceSupported` | ) | const`[inline]`

Convenience function for getting a AvatarInterface interface proxy object for this account.

Deprecated:
  Use optionalInterface() instead.

Returns:
  A pointer to the existing Client::AccountInterfaceAvatarInterface object for this Account object.

void Tp::Account::removed | ( |  | ) | `[signal]`

void Tp::Account::serviceNameChanged | ( | const QString & | serviceName | ) | `[signal]`

This signal is emitted when the value of serviceName() of this account changes.

Parameters:

  | serviceName | The new service name of this account.

See also:
  serviceName(), setServiceName()

void Tp::Account::profileChanged | ( | const Tp::ProfilePtr & | profile | ) | `[signal]`

This signal is emitted when the value of profile() of this account changes.

Parameters:

  | profile | The new profile of this account.

See also:
  profile()

void Tp::Account::displayNameChanged | ( | const QString & | displayName | ) | `[signal]`

This signal is emitted when the value of displayName() of this account changes.

Parameters:

  | displayName | The new display name of this account.

See also:
  displayName(), setDisplayName()

void Tp::Account::iconChanged | ( | const QString & | icon | ) | `[signal]`

This signal is emitted when the value of icon() of this account changes.

Parameters:

  | icon | The new icon name of this account.

See also:
  icon(), setIcon()

void Tp::Account::iconNameChanged | ( | const QString & | iconName | ) | `[signal]`

This signal is emitted when the value of iconName() of this account changes.

Parameters:

  | iconName | The new icon name of this account.

See also:
  iconName(), setIconName()

void Tp::Account::nicknameChanged | ( | const QString & | nickname | ) | `[signal]`

This signal is emitted when the value of nickname() of this account changes.

Parameters:

  | nickname | The new nickname of this account.

See also:
  nickname(), setNickname()

void Tp::Account::normalizedNameChanged | ( | const QString & | normalizedName | ) | `[signal]`

This signal is emitted when the value of normalizedName() of this account changes.

Parameters:

  | normalizedName | The new normalized name of this account.

See also:
  normalizedName()

void Tp::Account::validityChanged | ( | bool | validity | ) | `[signal]`

This signal is emitted when the value of isValidAccount() of this account changes.

Parameters:

  | validity | The new validity of this account.

See also:
  isValidAccount()

void Tp::Account::stateChanged | ( | bool | state | ) | `[signal]`

This signal is emitted when the value of isEnabled() of this account changes.

Parameters:

  | state | The new state of this account.

See also:
  isEnabled()

void Tp::Account::capabilitiesChanged | ( | Tp::ConnectionCapabilities * | capabilities | ) | `[signal]`

void Tp::Account::connectsAutomaticallyPropertyChanged | ( | bool | connectsAutomatically | ) | `[signal]`

This signal is emitted when the value of connectsAutomatically() of this account changes.

Parameters:

  | connectsAutomatically | The new value of connects automatically property of this account.

See also:
  isEnabled()

void Tp::Account::firstOnline | ( |  | ) | `[signal]`

This signal is emitted when this account is first put online.

See also:
  hasBeenOnline()

void Tp::Account::parametersChanged | ( | const QVariantMap & | parameters | ) | `[signal]`

This signal is emitted when the value of parameters() of this account changes.

Parameters:

  | parameters | The new parameters of this account.

See also:
  parameters()

void Tp::Account::changingPresence | ( | bool | value | ) | `[signal]`

This signal is emitted when the value of isChangingPresence() of this account changes.

Parameters:

  | value | Whether this account's connection is changing presence.

See also:
  isChangingPresence()

void Tp::Account::automaticPresenceChanged | ( | const Tp::SimplePresence & | automaticPresence | ) | const`[signal]`

This signal is emitted when the value of automaticPresence() of this account changes.

Parameters:

  | automaticPresence | The new value of automatic presence property of this account.

See also:
  automaticPresence()

void Tp::Account::currentPresenceChanged | ( | const Tp::SimplePresence & | currentPresence | ) | const`[signal]`

This signal is emitted when the value of currentPresence() of this account changes.

Parameters:

  | currentPresence | The new value of current presence property of this account.

See also:
  currentPresence()

void Tp::Account::requestedPresenceChanged | ( | const Tp::SimplePresence & | requestedPresence | ) | const`[signal]`

This signal is emitted when the value of requestedPresence() of this account changes.

Parameters:

  | requestedPresence | The new value of requested presence property of this account.

See also:
  requestedPresence()

void Tp::Account::onlinenessChanged | ( | bool | online | ) | `[signal]`

void Tp::Account::avatarChanged | ( | const Tp::Avatar & | avatar | ) | `[signal]`

This signal is emitted when the value of avatar() of this account changes.

Parameters:

  | avatar | The new avatar of this account.

See also:
  avatar()

void Tp::Account::connectionStatusChanged | ( | Tp::Connection::Status | status | ) | `[signal]`

This signal is emitted when the connection status of this account changes.

Parameters:

  | status | The new status of this account connection.
  | statusReason | The new status reason of this account connection.
  | errorName | The D-Bus error name for the last disconnection or connection failure,
  | errorDetails | The error details related to errorName.

See also:
  connectionStatus(), connectionStatusReason(), connectionError(), connectionErrorDetails(), Connection::ErrorDetails

void Tp::Account::connectionStatusChanged | ( | Tp::ConnectionStatus | status,
|  | Tp::ConnectionStatusReason | statusReason |
| ) |  |  | `[signal]`

This signal is emitted when the value of connectionStatus() of this account changes.

Deprecated:
  Use connectionStatusChanged(Tp::Connection::Status status) instead.

Parameters:

  | status | The new status of this account connection.
  | statusReason | The new status reason of this account connection.

See also:
  connectionStatus(), connectionStatusReason()

void Tp::Account::statusChanged | ( | Tp::ConnectionStatus | status,
|  | Tp::ConnectionStatusReason | statusReason,
|  | const QString & | errorName,
|  | const QVariantMap & | errorDetails |
| ) |  |  | `[signal]`

This signal is emitted when the connection status of this account changes.

Deprecated:
  Use connectionStatusChanged(Tp::Connection::Status status) instead.

Parameters:

  | status | The new status of this account connection.
  | statusReason | The new status reason of this account connection.
  | errorName | The D-Bus error name for the last disconnection or connection failure,
  | errorDetails | A map containing extensible error details related to errorName.

See also:
  connectionStatus(), connectionStatusReason(), connectionError(), connectionErrorDetails(), Connection::ErrorDetails

void Tp::Account::connectionChanged | ( | const Tp::ConnectionPtr & | connection | ) | `[signal]`

This signal is emitted when the value of connection() of this account changes.

Parameters:

  | connection | A ConnectionPtr pointing to the new Connection object or a null ConnectionPtr if there is no connection.

See also:
  connection()

void Tp::Account::haveConnectionChanged | ( | bool | haveConnection | ) | `[signal]`

This signal is emitted when the value of haveConnection() of this account changes.

Deprecated:
  Use connectionChanged() instead.

Parameters:

  | haveConnection | Whether this account have a connection.

See also:
  haveConnection(), connection()

void Tp::Account::propertyChanged | ( | const QString & | propertyName | ) | `[signal]`

Client::AccountInterface * Tp::Account::baseInterface | ( |  | ) | const`[protected]`

Return the Client::AccountInterface interface proxy object for this account. This method is protected since the convenience methods provided by this class should generally be used instead of calling D-Bus methods directly.

Returns:
  A pointer to the existing Client::AccountInterface object for this Account object.

void Tp::Account::connectNotify | ( | const char * | signalName | ) | `[protected]`

## Member Data Documentation

const Feature Tp::Account::FeatureCore `[static]`

Feature representing the core that needs to become ready to make the Account object usable.

Note that this feature must be enabled in order to use most Account methods. See specific methods documentation for more details.

When calling isReady(), becomeReady(), this feature is implicitly added to the requested features.

const Feature Tp::Account::FeatureAvatar `[static]`

Feature used in order to access account avatar info.

See avatar specific methods' documentation for more details.

const Feature Tp::Account::FeatureProtocolInfo `[static]`

Feature used in order to access account protocol info.

See protocol info specific methods' documentation for more details.

const Feature Tp::Account::FeatureCapabilities `[static]`

Feature used in order to access account capabilities.

This feature will enable FeatureProtocolInfo and FeatureProfile.

See capabilities specific methods' documentation for more details.

const Feature Tp::Account::FeatureProfile `[static]`

Feature used in order to access account profile info.

See profile specific methods' documentation for more details.

## Property Documentation

bool Tp::Account::valid`[read]`

bool Tp::Account::enabled`[read]`

QString Tp::Account::cmName`[read]`

Return the connection manager name of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The connection manager name of this account.

QString Tp::Account::protocolName`[read]`

Return the protocol name of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The protocol name of this account.

QString Tp::Account::serviceName`[read]`

Return the service name of this account.

Note that this method will fallback to protocolName() if service name is not known.

This method requires Account::FeatureCore to be enabled.

Returns:
  The service name of this account.

See also:
  serviceNameChanged(), protocolName()

ProfilePtr Tp::Account::profile`[read]`

Return the profile used for this account.

Note that if a profile for serviceName() is not available, a fake profile (Profile::isFake() will return `true`) will be returned in case protocolInfo() returns non-NULL.

The fake profile will contain the following info:

- Profile::type() will return "IM"
- Profile::provider() will return an empty string
- Profile::serviceName() will return cmName()-serviceName()
- Profile::name() and Profile::protocolName() will return protocolName()
- Profile::iconName() will return "im-protocolName()"
- Profile::cmName() will return cmName()
- Profile::parameters() will return a list matching CM default parameters for protocol with name protocolName()
- Profile::presences() will return an empty list and Profile::allowOtherPresences() will return `true`, meaning that CM presences should be used
- Profile::unsupportedChannelClassSpecs() will return an empty list

This method requires Account::FeatureProfile to be enabled.

Returns:
  The profile for this account.

See also:
  profileChanged()

QString Tp::Account::displayName`[read]`

Return the display name of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The display name of this account.

See also:
  displayNameChanged()

QString Tp::Account::iconName`[read]`

Return the icon name of this account.

This method requires Account::FeatureCore to be enabled.

If the account has no icon, and Account::FeatureProfile is enabled, the icon from the result of profile() will be used.

If neither the account nor the profile has an icon, and Account::FeatureProtocolInfo is enabled, the icon from protocolInfo() will be used if set.

As a last resort, "im-" + protocolName() will be returned.

This matches the fallbacks recommended by the Telepathy specification.

Returns:
  The icon name of this account.

See also:
  iconNameChanged()

QString Tp::Account::nickname`[read]`

Return the nickname of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The nickname of this account.

See also:
  nicknameChanged()

const Avatar & Tp::Account::avatar`[read]`

Return the avatar of this account.

This method requires Account::FeatureAvatar to be enabled.

Returns:
  The avatar of this account.

See also:
  avatarChanged()

QVariantMap Tp::Account::parameters`[read]`

Return the parameters of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The parameters of this account.

See also:
  parametersChanged()

ProtocolInfo * Tp::Account::protocolInfo`[read]`

Return the protocol info of this account protocol.

This method requires Account::FeatureProtocolInfo to be enabled.

The returned pointer points to an internal data structure, which should not be deleted by the caller.

Returns:
  The protocol info of this account protocol.

ConnectionCapabilities * Tp::Account::capabilities`[read]`

Return the capabilities for this account.

This method requires Account::FeatureCapabilities to be enabled.

Note that this method will return the connection() capabilities if the account is online and ready. If the account is disconnected, it will fallback to return the subtraction of the protocolInfo() capabilities and the profile unsupported capabilities.

Returns:
  The capabilities for this account or 0 if FeatureCapabilities is not ready or the capabilities are unknown (e.g. the connection is offline and protocolInfo() returns 0).

bool Tp::Account::hasBeenOnline`[read]`

Return whether this account has ever been put online successfully.

This property cannot change from true to false, only from false to true. When the account successfully goes online for the first time, or when it is detected that this has already happened, the firstOnline() signal is emitted.

This method requires Account::FeatureCore to be enabled.

Returns:
  Whether the account has ever been online.

bool Tp::Account::connectsAutomatically`[read]`

Return whether this account should be put online automatically whenever possible.

This method requires Account::FeatureCore to be enabled.

Returns:
  `true` if it should try to connect automatically, `false` otherwise.

See also:
  connectsAutomaticallyPropertyChanged()

ConnectionStatus Tp::Account::connectionStatus`[read]`

Return the status of this account connection.

This method requires Account::FeatureCore to be enabled.

Returns:
  The status of this account connection.

See also:
  connectionStatusChanged()

ConnectionStatusReason Tp::Account::connectionStatusReason`[read]`

Return the status reason of this account connection.

This method requires Account::FeatureCore to be enabled.

Returns:
  The status reason of this account connection.

See also:
  connectionStatusChanged()

QString Tp::Account::connectionError`[read]`

Return the D-Bus error name for the last disconnection or connection failure, (in particular, TELEPATHY_ERROR_CANCELLED if it was disconnected by user request), or an empty string if the account is connected.

One can receive change notifications on this property by connecting to the statusChanged() signal.

This method requires Account::FeatureCore to be enabled.

Returns:
  The D-Bus error name for the last disconnection or connection failure.

See also:
  connectionErrorDetails(), connectionStatus(), connectionStatusReason(), statusChanged()

QVariantMap Tp::Account::connectionErrorDetails`[read]`

Return a map containing extensible error details related to connectionError().

The keys for this map are defined by the Telepathy D-Bus Interface Specification. They will typically include <literal>debug-message</literal>, which is a debugging message in the C locale.

One can receive change notifications on this property by connecting to the statusChanged() signal.

Connection::ErrorDetails can be used to wrap the returned map for more convenient access. In a future API/ABI incompatible version we'll change this method to return one.

This method requires Account::FeatureCore to be enabled.

Returns:
  A map containing extensible error details related to connectionError().

See also:
  connectionError(), connectionStatus(), connectionStatusReason(), statusChanged(), Connection::ErrorDetails.

bool Tp::Account::haveConnection`[read]`

Return whether this account has a connection object that can be retrieved using connection().

This method requires Account::FeatureCore to be enabled.

Deprecated:
  Use connection() instead.

Returns:
  `true` if a connection object can be retrieved, `false` otherwise.

See also:
  connection(), connectionChanged()

ConnectionPtr Tp::Account::connection`[read]`

Return the ConnectionPtr object of this account.

Note that the returned ConnectionPtr object will not be cached by the Account instance; applications should do it themselves.

Remember to call Connection::becomeReady on the new connection to make sure it is ready before using it.

This method requires Account::FeatureCore to be enabled.

Returns:
  A ConnectionPtr object pointing to the Connection object of this account, or a null ConnectionPtr if this account does not currently have a connection or if an error occurred.

See also:
  connectionChanged()

bool Tp::Account::changingPresence`[read]`

SimplePresence Tp::Account::automaticPresence`[read]`

Return the presence status that this account will have set on it by the account manager if it brings it online automatically.

This method requires Account::FeatureCore to be enabled.

Returns:
  The presence status that will be set by the account manager if this account is brought online automatically by it.

See also:
  automaticPresenceChanged()

SimplePresence Tp::Account::currentPresence`[read]`

Return the actual presence of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The actual presence of this account.

See also:
  currentPresenceChanged(), setRequestedPresence(), requestedPresence(), automaticPresence()

SimplePresence Tp::Account::requestedPresence`[read]`

Return the requested presence of this account.

This method requires Account::FeatureCore to be enabled.

Returns:
  The requested presence of this account.

See also:
  requestedPresenceChanged(), setRequestedPresence(), currentPresence(), automaticPresence()

bool Tp::Account::online`[read]`

QString Tp::Account::uniqueIdentifier`[read]`

Return the unique identifier of this account.

This identifier should be unique per AccountManager implementation, i.e. at least per QDBusConnection.

Returns:
  The unique identifier of this account.

QString Tp::Account::connectionObjectPath`[read]`

Return the connection object path of this account.

This method requires Account::FeatureCore to be enabled.

Deprecated:
  Use Connection::objectPath() instead.

Returns:
  The connection object path of this account.

See also:
  connectionChanged(), connection()

QString Tp::Account::normalizedName`[read]`

Return the normalized user ID of the local user of this account.

It is unspecified whether this user ID is globally unique.

As currently implemented, IRC user IDs are only unique within the same IRCnet. On some saner protocols, the user ID includes a DNS name which provides global uniqueness.

If this value is not known yet (which will always be the case for accounts that have never been online), it will be an empty string.

It is possible that this value will change if the connection manager's normalization algorithm changes.

This method requires Account::FeatureCore to be enabled.

Returns:
  Account normalized user ID of the local user.

See also:
  normalizedNameChanged()